#!/usr/local/bin/perl
# delete_queues.cgi
# Delete multiple messages from the postfix queue

require './postfix-lib.pl';
$access{'mailq'} || &error($text{'mailq_ecannot'});
&ReadParse();

if ($in{'move'}) {
	# Re-queuing messages
	foreach $f (split(/\0/, $in{'file'})) {
		&system_logged("postsuper -r ".quotemeta($f));
		}
	}
elsif ($in{'hold'}) {
	# Holding messages
	foreach $f (split(/\0/, $in{'file'})) {
		&system_logged("postsuper -h ".quotemeta($f));
		}
	}
elsif ($in{'unhold'}) {
	# Un-holding messages
	foreach $f (split(/\0/, $in{'file'})) {
		&system_logged("postsuper -H ".quotemeta($f));
		}
	}
else {
	# Deleting messages
	@qfiles = &recurse_files($config{'mailq_dir'});
	foreach $f (split(/\0/, $in{'file'})) {
		$f =~ /^[A-Za-z0-9]+$/ || next;
		if ($postfix_version >= 1.1) {
			&system_logged("postsuper -d ".quotemeta($f));
			}
		else {
			&unlink_file(grep { $_ =~ /\/$f$/ } @qfiles);
			}
		}
	if ($postfix_version < 1.1) {
		&system_logged("postsuper -p >/dev/null 2>&1");
		}
	}
&redirect("mailq.cgi");

